=== cmake/tribits/doc/sphinx/requirements.txt ===
Sphinx==8.2.1
sphinx-rtd-theme==3.0.2
