=== packages/seacas/applications/exo2mat/CMakeLists.txt ===

IF (TPL_ENABLE_Matio)
TRIBITS_SUBPACKAGE(Exo2mat)

LINK_DIRECTORIES(${Matio_LIBRARY_DIRS})
TRIBITS_INCLUDE_DIRECTORIES(
  "${Matio_INCLUDE_DIRS}"
  "${CMAKE_CURRENT_SOURCE_DIR}"
)

SET(CODE exo2mat)
SET(HEADERS "")

TRIBITS_ADD_EXECUTABLE(
  ${CODE}
  NOEXEPREFIX
  NOEXESUFFIX
  SOURCES exo2mat.C
  COMM serial mpi
  INSTALLABLE
  )

TRIBITS_SUBPACKAGE_POSTPROCESS()
ENDIF()
