=== packages/seacas/applications/mapvar-kd/CMakeLists.txt ===
INCLUDE(FortranSettings)

TRIBITS_SUBPACKAGE(Mapvar-kd)

TRIBITS_INCLUDE_DIRECTORIES(
  "${CMAKE_CURRENT_SOURCE_DIR}"
)

SET(HEADERS "")
APPEND_GLOB(SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.f)
APPEND_GLOB(SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

TRIBITS_ADD_EXECUTABLE(
  mapvar-kd
  NOEXEPREFIX
  NOEXESUFFIX
  LINKER_LANGUAGE Fortran
  SOURCES ${SOURCES}
  COMM serial mpi
  INSTALLABLE
  )

SET_PROPERTY(TARGET mapvar-kd  PROPERTY POSITION_INDEPENDENT_CODE TRUE)
TRIBITS_SUBPACKAGE_POSTPROCESS()
