=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --parallel

# TODO turn on tests as soon when <https://github.com/gdsjaar/seacas/issues/7>
# is resolved.
override_dh_auto_configure:
	dh_auto_configure -- \
  -DBUILD_SHARED_LIBS:BOOL=ON \
  -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
  -DHDF5_ROOT:PATH=/usr/ \
  -DSeacas_ENABLE_ALL_PACKAGES:BOOL=ON \
  -DSeacas_ENABLE_TESTS:BOOL=OFF \
  -DTPL_ENABLE_CGNS:BOOL=OFF \
  -DTPL_ENABLE_Matio:BOOL=ON \
  -DTPL_ENABLE_METIS:BOOL=ON \
  -DTPL_ENABLE_ParMETIS:BOOL=ON \
  -DTPL_ENABLE_Netcdf:BOOL=ON \
  -DTPL_ENABLE_MPI:BOOL=OFF \
  -DTPL_ENABLE_Pamgen:BOOL=OFF \
  -DTPL_ENABLE_X11:BOOL=OFF \
  -DTPL_ENABLE_Zlib:BOOL=ON
